//#include <string>
//#include <iostream>
//#include <sstream>
//#include <stdio.h>
//#include <math.h>
//#include "ics46goody.hpp"
//
//
////Choose one or the other hash function (or write your own)
//
////std::hash<std::string> hash;
//
//int hash(const std::string& s) {
//  int hash = 0;
//  unsigned size = s.size();
//  for (unsigned i = 0; i < size; ++i)
//    hash = 31*hash + s[i];   //promotion of char -> int: its ASCII value
//  return hash;
//};
//
////unsigned int hash (const std::string& s)
////{
////  unsigned int hash = 5381;
////
////  for (unsigned int i = 0; i < s.length(); i++)
////    hash = (hash << 5) + hash + (unsigned int)s[i];
////
////  return hash;
////}
//
//std::string with_commas (int value) {
//  std::string s = "";
//  int count = 0;
//  while (value != 0) {
//    if (++count == 4) {
//      s = "," + s;
//      count = 1;
//    }
//    s = (char)('0'+ value%10) + s;
//    value /= 10;
//  }
//  return s == "" ? "0" : s;
//}
//
//
//std::string random_string(std::string alphabet, int length) {
//  char s[length+1];
//  for (int i=0; i<length; ++i)
//    s[i] = alphabet[ics::rand_range(0,alphabet.size()-1)];
//  s[length] = '\0';
//  return std::string(s);
//}
//
//
//
//
//
//int main() {
//  std::cout << "Testing random Strings = a specific length" << std::endl;
//  int         heart_beat  = 100000;
//  int         num_bins    = ics::prompt_int    ("Enter size of hash table to use    ", 1000000);
//  std::string all_chars   = ics::prompt_string ("Enter characters in strings to test","abcdefghijklmnopqrstuvwxyz");
//  int         length      = ics::prompt_int    ("Enter the length of strings to test", 10);
//  int         num_test    = ics::prompt_int    ("Enter # of random string to test  ", num_bins);
//  int* occupied = new int[num_bins];           //Must be dynamically allocated for huge arrays
//
//  std::cout << "Processing:" << std::endl;
//
//  for (int i=0; i<num_bins; ++i)
//    occupied[i] = 0;
//
//  //Generate num_test random strings, hash them, and record their bin
//  for (int progress = 0; progress<num_test; /* see body */) {
//    int h = abs(hash(random_string(all_chars,length)))%num_bins;
//    ++occupied[h];
//
//    if (++progress%heart_beat == 0) {
//      std::cout << " " << with_commas(progress);
//      if (progress%(heart_beat*10) == 0)
//        std::cout << std::endl;
//    }
//  }
//
//  //Compute the largest number of values hashing to any bin
//  int max_occupied = 0;
//  for (int i=0; i<num_bins; ++i) {
//    max_occupied = std::max(max_occupied,occupied[i]);
//  }
//
//  //Print simple statistics
//  std::cout << "\n\nSimple Statistics:" << std::endl;
//  std::cout << "  # Bins in Hash Table                         = " << with_commas(num_bins) << std::endl;
//  std::cout << "  # Hashed Values                              = " << with_commas(num_test) << std::endl;
//  std::cout << "  Minimum Occupied in Bin with perfect hashing = " << with_commas(num_test/num_bins) << std::endl;
//  std::cout << "  Maximum Occupied in an actual Bin            = " << max_occupied << std::endl;
//  std::cout << std::endl;
//
//  //Compute the number of bins with 0 to the largest number of values in any bin
//  int bin_stat[max_occupied+1];
//  for (int i=0; i<=max_occupied; ++i)
//    bin_stat[i] = 0;
//  for (int i=0; i<num_bins; ++i)
//    ++bin_stat[occupied[i]];
//
//  //Calculate/Print detailed collision statistics
//  std::cout << "Detailed Statistics:" << std::endl;
//  int probes = 0;
//  int cumulative = 0;
//  for (int i=0; i<=max_occupied; ++i) {
//    cumulative += i*bin_stat[i];
//    if (bin_stat[i] != 0)
//      printf("  # bins with %5i hashed values = %10s containing a total of %10s values(%3i%%); %10s cumulative(%3i%%)\n",
//             i, with_commas(bin_stat[i]).c_str(), with_commas(i*bin_stat[i]).c_str(), (int)round((double)100*i*bin_stat[i]/num_test),
//                with_commas(cumulative).c_str(),  (int)round((double)100*cumulative/num_test));
//    probes += i*(i+1)/2*bin_stat[i];
//  }
//
//  std::cout << std::endl;
//  std::cout << "Average probes/lookup = " << (double)probes/num_test << std::endl;
//}
//
