//#include <string>
//#include <iostream>
//#include <sstream>
//#include "ics46goody.hpp"
//
//
////Choose one or the other hash function (or write your own)
//
////std::hash<std::string> hash;
//int hash(std::string s) {
//  int hash = 0;
//  unsigned size = s.size();
//  for (unsigned i = 0; i < size; ++i)
//    hash = 31*hash + s[i];   //promotion of char -> int: its ASCII value
//  return hash;
//};
//
//
//std::string with_commas (int value) {
//  std::string s = "";
//  int count = 0;
//  while (value != 0) {
//    if (++count == 4) {
//      s = "," + s;
//      count = 1;
//    }
//    s = (char)('0'+ value%10) + s;
//    value /= 10;
//  }
//  return s == "" ? "0" : s;
//}
//
//
//std::string random_string(std::string alphabet, int length) {
//  char s[length+1];
//  for (int i=0; i<length; ++i)
//    s[i] = alphabet[ics::rand_range(0,alphabet.size()-1)];
//  s[length] = '\0';
//  return std::string(s);
//}
//
//
//
//
//
//int main() {
//  std::cout << "Testing random Strings = a specific length" << std::endl;
//  std::string allowable_percent[] = {"1","5","10",""};
//  std::string allowable_probe[] = {"l","q",""};
//
//  int         percent     = atoi(ics::prompt_string("Enter % value added for data reports    ", "5", allowable_percent).c_str());
//  int         num_bins    = ics::prompt_int        ("Enter size of hash table to use         ", 1000000);
//  std::string all_chars   = ics::prompt_string     ("Enter characters in strings to test     ","abcdefghijklmnopqrstuvwxyz");
//  int         length      = ics::prompt_int        ("Enter the length of strings to test     ", 10);
//  std::string probeType   = ics::prompt_string     ("Enter probe type ([l]inear, [q]uadratic)", "l",allowable_probe);
//  bool        all_details = ics::prompt_bool       ("Display all bin details                 ",false);
//  int*        occupied    = new int[num_bins];     //Must be dynamically allocated for huge arrays
//  int         num_test    = num_bins;              //For open hashing, # bins limits number of values in the hash table
//
//  std::cout << "Processing:" << std::endl;
//
//  for (int i=0; i<num_bins; ++i)
//    occupied[i] = 0;
//
//  //Generate num_test random strings, hash them, and record their bins
//  //Many might have to be searched because of open hashing
//  for (int progress = 0; progress<num_test; /* see body */) {
//    int h = abs(hash(random_string(all_chars,length)))%num_bins;
//
//    //Find bin in which to put new value (must be empty: occupied[bin] == 0)
//    //Increment value in every bin visited by open hashing
//    int j = 1;
//    while (occupied[h] != 0) {      //while (++occupied[h]++ != 1)
//      ++occupied[h];                //  if ()...
//      if (probeType == "l")
//        h = (h+1)%num_bins;
//      else if (probeType == "q") {
//        h = abs(h+j)%num_bins;
//        ++j;
//      }
//    }
//    occupied[h] = 1;
//
//    //Print statistics for every 1% (or 5% or 10%) values added to hash table
//    ++progress;
//    if (progress%(num_test/(100/percent)) == 0) {
//
//      //Compute the largest number of values examined in any bin
//      int max = 0;
//      for (int i=0; i<num_bins; ++i) {
//        max = std::max(max,occupied[i]);
//      }
//
//      //Compute the number of values hashing in each bin from 0 to the largest number of values hashing into any bin
//      int bin_stat[max+1];
//      for (int i=0; i<=max; ++i)
//        bin_stat[i] = 0;
//      for (int i=0; i<num_bins; ++i) {
//        ++bin_stat[occupied[i]];
//      }
//
//     //Print detailed statistics
//     int probes = 0;
//      for (int i=0; i<=max; ++i) {
//        if (all_details) {//For compiler
//          if (i == 0)
//            std::cout << "  # filled/empty bins = " << with_commas(progress) << "/" << with_commas(bin_stat[i]) << std::endl;
//          else
//            std::cout << "  # bins requiring " << i << " probes = " << with_commas(bin_stat[i]) << std::endl;
//        }
//
//        probes += i*bin_stat[i];
//      }
//
//      std::cout << "  With " << with_commas(progress) << " values (" << progress/(num_test/(100/percent))*percent << "% load factor): Average probes/lookup = " << (double)probes/progress << std::endl;
//      if (all_details)
//        std::cout << std::endl;
//    }
//  }
//}
